class Node:
    
    def __init__(self, state, action=None, parent=None, path_cost=0):
        self.state = state
        self.action = action
        self.parent = parent
        self.path_cost = path_cost
    
    def expand(self, problem):
        actions = problem.get_actions(self.state)
        successors = []
        for action in actions:
            new_state = problem.get_successor(self.state, action)
            new_node = Node(new_state, action, self, problem.get_cost(self.state, action) + self.path_cost)
            successors.append(new_node)
        return successors
    
    def get_path(self):
        path = []
        curr_node = self
        while curr_node.parent != None:
            path.append(curr_node.action)
            curr_node = curr_node.parent
        return path[::-1]
    
    def __lt__(self, curr_node):
        return self.path_cost < curr_node.path_cost