class SlidingPuzzle:
    
    def __init__(self, start, goal):
        self.start = start
        self.goal = goal
    
    # provjera da li je neko stanje ciljno
    def is_goal(self, state):
        return state == self.goal
    
    def find_blank(self, state):
        return 45 - sum(state)
    
    # koje su dozvoljenje akcije u nekom stanju
    # U, D, L, R
    def get_actions(self, state):
        
        pos_blank = self.find_blank(state)
        actions = []
        
        if pos_blank > 3:
            actions.append('D')
        if pos_blank < 7:
            actions.append('U')
        if pos_blank % 3 != 1:
            actions.append('R')
        if pos_blank % 3 != 0:
            actions.append('L')
        
        return actions
    
    # prelazi izmedju stanja - successor funkcije
    def get_successor(self, state, action):
        
        pos_blank = self.find_blank(state)
        
        if action == 'U':
            pos_piece = pos_blank + 3
        elif action == 'D':
            pos_piece = pos_blank - 3
        elif action == 'L':
            pos_piece = pos_blank + 1
        elif action == 'R':
            pos_piece = pos_blank - 1
        
        piece = state.index(pos_piece)
        new_state = state[:piece] + (pos_blank,) + state[piece+1:]
        
        return new_state
    
    # stampa stanja
    def print_state(self, state):
        mat = [[0 for j in range(3)] for i in range(3)]
        for piece, pos in enumerate(state, start=1):
            i = (pos - 1) // 3
            j = (pos - 1) % 3
            mat[i][j] = piece
        for i in range(3):
            for j in range(3):
                if mat[i][j] == 0:
                    print(' ', end=' ')
                else:
                    print(mat[i][j], end=' ')
            print()
        print()
    
    def get_cost(self, state, action):
        return 1